/*
*            k145u.ino
*  базовый модуль имиации часов 
*   на основе К145ИК1901
*  расширенная версия на основе
*  ардуино-нано (про-мини),
*  RTC DS3231,
*  10-позиционного ЖКИ дисплея на NJU6432x
*  и минимальной клавиатуры (4-5 кнопок)
*  используюшей курсор с привязкой
*  к "пиктограммам"
*  с возможностью расширения функционала ПРВ
*  
*/
//---------------------------------------------------------
#include "k145u.h"

//---------------------------------------------------------
// создание экземпляра класса индикатора nju
nju njx(PinNoInh, PinDn, PinScl, PinCe);
// создание класса mxiic
mxiic my_iic(L_SDA, L_SCL);


//---------------------------------------------------------
void setup() {
  // put your setup code here, to run once:

 Serial.begin(9600);
 
 // запуск сканера кнопок
 skan_init();
 // инициализация "волшкбной кнопы"
 // для HardRTC_init (RK)
 //pinMode(PinToV, INPUT_PULLUP);
 //digitalWrite(PinToV, HIGH);
 // инициализация сигнально-силовых выходных линий
 iTmrO();
 digitalWrite(HLbud, LOW); pinMode(HLbud, OUTPUT);
 digitalWrite(DTM, LOW); pinMode(DTM, OUTPUT);
 // инициализация аппаратных выводов программного I2C
 my_iic.mx_init();
 // инициализация дисплея
 njx.init();
 /* первичная инициализация RTC DS3231 при
 первичной подаче питания и зажатой
 при включении питания(после аппаратного reset)
 кнопке RK */
 if(!(digitalRead(PinToV))){HardRTC_init();}
 
 // запуск обработчика секунд-генератора
 genSecInit();
 // открытие панели главных часов
 dev0_init(); //DevClockInit();
 
 




}

void loop() {
  // put your main code here, to run repeatedly:

 if (QtTm)
 {
  QtTm = 0; KeyDevFnSel(); ErIrqRTC++;
  if (ErIrqRTC >= 150){ ERROR_RTC(); }
 }
 if (SecF)
 {
  ErIrqRTC = 0; SecF = 0; clock();
  if(!DisClcInd){ vrClcDisp(); }
  if(SecEN){ SecPlus(); }
  if(En_TmrF){ Tmr_wrk(); }


  
 }








}

//---------------------------------------------------------


//---------------------------------------------------------

//---------------------------------------------------------


//---------------------------------------------------------
//------------------------------------------------------------------------
// селектор задач для активных кноп/комбинаций кноп
// текущего устройства
void KeyDevFnSel()
{
 switch (SnDat) {
  case mask0:
    KeyPtrZ(); // "все отпущены"
   break;
  case mask1:
    KeyPtrL(); // указатель на функцию кнопки "<<"
   break;
  case mask2:
    KeyPtrR(); // указатель на функцию кнопки ">>"
   break;
  case mask3:
    KeyPtrP(); // указатель на функцию кнопки "+"
   break;
  case mask4:
    KeyPtrM(); // указатель на функцию кнопки "-"
   break;
  case mask5:
    KeyPtrRK(); // указатель на функцию кнопки "RK"
   break;
/*
  case mask6:
    KeyPtr_LR(); // указатель на функцию кнопки "<<" & ">>"
   break;
  case mask7:
    KeyPtr_PM(); // указатель на функцию кнопки "+" & "-"
   break;
  case mask8:
    KeyPtr_LP(); // указатель на функцию кнопки "<<" & "+"
   break;
  case mask9:
    KeyPtr_RP(); // указатель на функцию кнопки ">>" & "+"
   break;
  case mask10:
    KeyPtr_LM(); // указатель на функцию кнопки "<<" & "-"
   break;
  case mask11:
    KeyPtr_RM(); // указатель на функцию кнопки ">>" & "-"
   break;
*/
  default: 
   // if nothing else matches, do the default
   // default is optional
   // ? склерозник повреждения ("зажатие") кноп ?
   break;
  }
}

//---------------------------------------------------------

//---------------------------------------------------------

//---------------------------------------------------------





//------------------------------------------------------------------------
//-------------конец файла/end of file---------------------
